/* 

Allan Spale
CS 488
Assignment 1

This class will manage the calculation, comparison, and string coversion
of calendar dates.  In order to increase efficiency (i.e. no function
calls for every day, month, and year access), the date class member 
vairables are made public instead of being private.  The interval class 
variable is used to step forward and backward through time.

*/

#ifndef __CALENDARDATE_H__
#define __CALENDARDATE_H__

#include <stdio.h>

class CalendarDate {
	
	public:
		CalendarDate();
		void zGoForward30Days();  // 30 days ~ 1 month
		void zGoForwardInterval();
		void zGoBackwardInterval();
		static void szSetIntervalOfDays( int iNumberOfDays );
		bool bIsLessThan( CalendarDate cdDate );
		bool bIsEqualTo( CalendarDate cdDate );
		bool bIsGreaterThan( CalendarDate cdDate );
		char *cpDisplayDate();
		void zSetCalendarDate( CalendarDate cdDate );
		static long slCountDaysInInterval( CalendarDate clStart,
										   CalendarDate clEnd );

		// made public to increase efficiency
		int iYear;
		int iMonth;
		int iDay;
		char *cpStringDate;

	private:
		void zConvertToStringDate();
		static const int I1D_NUMBER_OF_DAYS_IN_MTH[ 13 ];
		static int iInterval;
};

#endif			
