/* 

Allan Spale
CS 488
Assignment 1

This class will read the landscape and data files for the 2-D earthquake
visualization.  It will also answer data requests about extreme values
of the landscape.

*/


#ifndef __DATAMANAGEMENT_H__
#define __DATAMANAGEMENT_H__

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <string.h>
#include "CalendarDate.h"
#include "LandscapeLocation.h"
#include "QuakeData.h"
#include "QuakeLocation.h"
#include "TimeUTC.h"

class DataManagement {

	public:
		// FUNCTIONS
		DataManagement();
		~DataManagement();
		QuakeData * qdpGetEarthquakeData();
		LandscapeLocation * llpGetLandscapeData();
		bool bSetMinimumMagnitudeFilter( int iMagnitude );
		bool bReadDataFiles( const char *kcpLandscapeFilename,
							const char *kcpDataFilename );
		int iGetMaximumLongitude();
		int iGetMinimumLongitude();
		int iGetMaximumLatitude();
		int iGetMinimumLatitude();
		long lGetQuakeDataSize();
		long lGetLandscapeDataSize();
		
		// buffer for reading from file
		static const int KI_BUFFER_SIZE;


	private:
		int iLandscapeStructSize, iQuakeStructSize, iMaximumLatitude,
			iMaximumLongitutde, iMinimumLatitude, iMinimumLongitude;
		long lQuakeDataSize, lLandscapeDataSize, lFilteredQuakeDataSize;
		QuakeData *qdpQuakeData;
		LandscapeLocation *llpLandscape;
};

#endif